//
// Queue.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Queue: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var queueTransactionKeyNumeric: Double?
    public var resourceRecordKeyNumeric: Double?
    public var originatingSystemID: Double?
    public var originatingSystemName: String?
    public var originatingSystemQueueKey: String?
    public var queueTransactionKey: String?
    public var resourceRecordID: String?
    public var resourceRecordKey: String?
    public var sourceSystemID: String?
    public var sourceSystemName: String?
    public var sourceSystemQueueKey: String?
    public var className: String?
    public var queueTransactionType: String?
    public var resourceName: String?
    public var modificationTimestamp: Date?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?

    public init(id: Int? = nil, queueTransactionKeyNumeric: Double? = nil, resourceRecordKeyNumeric: Double? = nil, originatingSystemID: Double? = nil, originatingSystemName: String? = nil, originatingSystemQueueKey: String? = nil, queueTransactionKey: String? = nil, resourceRecordID: String? = nil, resourceRecordKey: String? = nil, sourceSystemID: String? = nil, sourceSystemName: String? = nil, sourceSystemQueueKey: String? = nil, className: String? = nil, queueTransactionType: String? = nil, resourceName: String? = nil, modificationTimestamp: Date? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil) {
        self.id = id
        self.queueTransactionKeyNumeric = queueTransactionKeyNumeric
        self.resourceRecordKeyNumeric = resourceRecordKeyNumeric
        self.originatingSystemID = originatingSystemID
        self.originatingSystemName = originatingSystemName
        self.originatingSystemQueueKey = originatingSystemQueueKey
        self.queueTransactionKey = queueTransactionKey
        self.resourceRecordID = resourceRecordID
        self.resourceRecordKey = resourceRecordKey
        self.sourceSystemID = sourceSystemID
        self.sourceSystemName = sourceSystemName
        self.sourceSystemQueueKey = sourceSystemQueueKey
        self.className = className
        self.queueTransactionType = queueTransactionType
        self.resourceName = resourceName
        self.modificationTimestamp = modificationTimestamp
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case queueTransactionKeyNumeric = "QueueTransactionKeyNumeric"
        case resourceRecordKeyNumeric = "ResourceRecordKeyNumeric"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemName = "OriginatingSystemName"
        case originatingSystemQueueKey = "OriginatingSystemQueueKey"
        case queueTransactionKey = "QueueTransactionKey"
        case resourceRecordID = "ResourceRecordID"
        case resourceRecordKey = "ResourceRecordKey"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemName = "SourceSystemName"
        case sourceSystemQueueKey = "SourceSystemQueueKey"
        case className = "ClassName"
        case queueTransactionType = "QueueTransactionType"
        case resourceName = "ResourceName"
        case modificationTimestamp = "ModificationTimestamp"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(queueTransactionKeyNumeric, forKey: .queueTransactionKeyNumeric)
        try container.encodeIfPresent(resourceRecordKeyNumeric, forKey: .resourceRecordKeyNumeric)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(originatingSystemQueueKey, forKey: .originatingSystemQueueKey)
        try container.encodeIfPresent(queueTransactionKey, forKey: .queueTransactionKey)
        try container.encodeIfPresent(resourceRecordID, forKey: .resourceRecordID)
        try container.encodeIfPresent(resourceRecordKey, forKey: .resourceRecordKey)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(sourceSystemQueueKey, forKey: .sourceSystemQueueKey)
        try container.encodeIfPresent(className, forKey: .className)
        try container.encodeIfPresent(queueTransactionType, forKey: .queueTransactionType)
        try container.encodeIfPresent(resourceName, forKey: .resourceName)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
    }
}

